Index: /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/mpp.f90
===================================================================
--- /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/mpp.f90	(revision 5599)
+++ /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/mpp.f90	(revision 5600)
@@ -656,20 +840,22 @@
    !
    !> @author J.Paul
-   !> @date Nov, 2013
-   !
-   !> @param[in] cd_file : file name of one file composing mpp domain
-   !> @param[in] td_var : variable structure
-   !> @param[in] id_niproc : number of processors following i
-   !> @param[in] id_njproc : number of processors following j
-   !> @param[in] id_nproc  : total number of processors
-   !> @param[in] id_preci  : i-direction overlap region
-   !> @param[in] id_precj  : j-direction overlap region
-   !> @param[in] cd_type   : type of the files (cdf, cdf4, dimg)
+   !> @date November, 2013 - Initial version
+   !
+   !> @param[in] cd_file   file name of one file composing mpp domain
+   !> @param[in] td_var    variable structure
+   !> @param[in] id_niproc number of processors following i
+   !> @param[in] id_njproc number of processors following j
+   !> @param[in] id_nproc  total number of processors
+   !> @param[in] id_preci  i-direction overlap region
+   !> @param[in] id_precj  j-direction overlap region
+   !> @param[in] cd_type   type of the files (cdf, cdf4, dimg)
+   !> @param[in] id_perio  NEMO periodicity index
+   !> @param[in] id_pivot  NEMO pivot point index F(0),T(1)
    !> @return mpp structure
    !-------------------------------------------------------------------
-   !> @code
    TYPE(TMPP) FUNCTION mpp__init_var( cd_file, td_var,               &
    &                                  id_niproc, id_njproc, id_nproc,&
-   &                                  id_preci, id_precj, cd_type )
+   &                                  id_preci, id_precj, cd_type,   &
+   &                                  id_perio, id_pivot )
       IMPLICIT NONE
       ! Argument
@@ -682,16 +868,22 @@
       INTEGER(i4),      INTENT(IN), OPTIONAL :: id_precj
       CHARACTER(LEN=*), INTENT(IN), OPTIONAL :: cd_type
+      INTEGER(i4),      INTENT(IN), OPTIONAL :: id_perio
+      INTEGER(i4),      INTENT(IN), OPTIONAL :: id_pivot
 
       ! local variable
-      INTEGER(i4), DIMENSION(:,:), ALLOCATABLE :: il_mask
+      INTEGER(i4), DIMENSION(:,:,:), ALLOCATABLE :: il_mask
       !----------------------------------------------------------------
 
       IF( ASSOCIATED(td_var%d_value) )THEN
-         ALLOCATE( il_mask(td_var%t_dim(1)%i_len, td_var%t_dim(2)%i_len) )
-         il_mask(:,:)=var_get_mask(td_var)
+         ALLOCATE( il_mask(td_var%t_dim(1)%i_len, &
+         &                 td_var%t_dim(2)%i_len, &
+         &                 td_var%t_dim(3)%i_len) )
+         il_mask(:,:,:)=var_get_mask(td_var)
          
-         mpp__init_var=mpp_init( cd_file, il_mask(:,:),         &
+         mpp__init_var=mpp_init( cd_file, il_mask(:,:,1),       &
          &                       id_niproc, id_njproc, id_nproc,&
-         &                       id_preci, id_precj, cd_type )
+         &                       id_preci, id_precj, cd_type,   &
+         &                       id_ew=td_var%i_ew, &
+         &                       id_perio=id_perio, id_pivot=id_pivot)
 
          DEALLOCATE(il_mask)
@@ -701,31 +893,49 @@
 
    END FUNCTION mpp__init_var
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This function initalise a mpp structure, 
-   !> reading one restart dimg file, or some netcdf files.
-   !
+   !-------------------------------------------------------------------
+   !> @brief This function initalise a mpp structure given file structure. 
    !> @details 
-   !>
-   !> @warning td_file should be not opened
-   !>
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_file : file strcuture
+   !> It reads restart dimg files, or some netcdf files.
+   !>
+   !> @warning 
+   !>  netcdf file must contains some attributes:
+   !>    - DOMAIN_number_total 
+   !>    - DOMAIN_size_global
+   !>    - DOMAIN_number
+   !>    - DOMAIN_position_first
+   !>    - DOMAIN_position_last
+   !>    - DOMAIN_halo_size_start
+   !>    - DOMAIN_halo_size_end
+   !>  or the file is assume to be no mpp file.
+   !>  
+   !> 
+   !>
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] td_file   file strcuture
+   !> @param[in] id_ew     east-west overlap
+   !> @param[in] id_perio  NEMO periodicity index
+   !> @param[in] id_pivot  NEMO pivot point index F(0),T(1)
    !> @return mpp structure
    !-------------------------------------------------------------------
-   ! @code
-   TYPE(TMPP) FUNCTION mpp__init_read( td_file )
+   TYPE(TMPP) FUNCTION mpp__init_file( td_file, id_ew, id_perio, id_pivot )
       IMPLICIT NONE
 
       ! Argument
       TYPE(TFILE), INTENT(IN) :: td_file
+      INTEGER(i4), INTENT(IN), OPTIONAL :: id_ew
+      INTEGER(i4), INTENT(IN), OPTIONAL :: id_perio
+      INTEGER(i4), INTENT(IN), OPTIONAL :: id_pivot
 
       ! local variable
       TYPE(TMPP)  :: tl_mpp
+      
       TYPE(TFILE) :: tl_file
+      
       TYPE(TDIM)  :: tl_dim
+
       TYPE(TATT)  :: tl_att
+
       INTEGER(i4) :: il_nproc
       INTEGER(i4) :: il_attid
@@ -737,5 +947,5 @@
 
       ! clean mpp
-      CALL mpp_clean(mpp__init_read)
+      CALL mpp_clean(mpp__init_file)
 
       ! check file type
@@ -743,6 +953,5 @@
          CASE('cdf')
             ! need to read all file to get domain decomposition
-
-            tl_file=td_file
+            tl_file=file_copy(td_file)
 
             ! open file
@@ -750,5 +959,5 @@
 
             ! read first file domain decomposition
-            tl_mpp=mpp__init_read_cdf(tl_file)
+            tl_mpp=mpp__init_file_cdf(tl_file)
 
             ! get number of processor/file to be read
@@ -779,19 +988,19 @@
 
                   ! read domain decomposition
-                  tl_mpp = mpp__init_read_cdf(tl_file)
+                  tl_mpp = mpp__init_file_cdf(tl_file)
                   IF( ji == 1 )THEN
-                     mpp__init_read=tl_mpp
+                     mpp__init_file=mpp_copy(tl_mpp)
                   ELSE
-                     IF( ANY( mpp__init_read%t_dim(1:2)%i_len /= &
+                     IF( ANY( mpp__init_file%t_dim(1:2)%i_len /= &
                                       tl_mpp%t_dim(1:2)%i_len) )THEN
 
-                        CALL logger_error("INIT READ: dimension from file "//&
+                        CALL logger_error("MPP INIT READ: dimension from file "//&
                         &     TRIM(tl_file%c_name)//" and mpp strcuture "//&
-                        &     TRIM(mpp__init_read%c_name)//"differ ")
+                        &     TRIM(mpp__init_file%c_name)//"differ ")
 
                      ELSE
 
                         ! add processor to mpp strcuture
-                        CALL mpp__add_proc(mpp__init_read, tl_mpp%t_proc(1))
+                        CALL mpp__add_proc(mpp__init_file, tl_mpp%t_proc(1))
 
                      ENDIF
@@ -802,74 +1011,84 @@
 
                ENDDO
-               IF( mpp__init_read%i_nproc /= il_nproc )THEN
-                  CALL logger_error("INIT READ: some processors can't be added &
+               IF( mpp__init_file%i_nproc /= il_nproc )THEN
+                  CALL logger_error("MPP INIT READ: some processors can't be added &
                   &               to mpp structure")
                ENDIF
 
             ELSE
-               mpp__init_read=tl_mpp
+               mpp__init_file=mpp_copy(tl_mpp)
             ENDIF
 
             ! mpp type
-            mpp__init_read%c_type=TRIM(td_file%c_type)
+            mpp__init_file%c_type=TRIM(td_file%c_type)
 
             ! mpp domain type
-            CALL mpp_get_dom(mpp__init_read)
+            CALL mpp_get_dom(mpp__init_file)
 
             ! create some attributes for domain decomposition (use with dimg file)
-            tl_att=att_init( "DOMAIN_number_total", mpp__init_read%i_nproc )
-            CALL mpp_add_att(mpp__init_read, tl_att)
-
-            tl_att=att_init( "DOMAIN_I_position_first", mpp__init_read%t_proc(:)%i_impp )
-            CALL mpp_add_att(mpp__init_read, tl_att)
-
-            tl_att=att_init( "DOMAIN_J_position_first", mpp__init_read%t_proc(:)%i_jmpp )
-            CALL mpp_add_att(mpp__init_read, tl_att)
-
-            tl_att=att_init( "DOMAIN_I_position_last", mpp__init_read%t_proc(:)%i_lci )
-            CALL mpp_add_att(mpp__init_read, tl_att)
-
-            tl_att=att_init( "DOMAIN_J_position_last", mpp__init_read%t_proc(:)%i_lcj )
-            CALL mpp_add_att(mpp__init_read, tl_att)
-
-            tl_att=att_init( "DOMAIN_I_halo_size_start", mpp__init_read%t_proc(:)%i_ldi )
-            CALL mpp_add_att(mpp__init_read, tl_att)
-
-            tl_att=att_init( "DOMAIN_J_halo_size_start", mpp__init_read%t_proc(:)%i_ldj )
-            CALL mpp_add_att(mpp__init_read, tl_att)
-
-            tl_att=att_init( "DOMAIN_I_halo_size_end", mpp__init_read%t_proc(:)%i_lei )
-            CALL mpp_add_att(mpp__init_read, tl_att)
-
-            tl_att=att_init( "DOMAIN_J_halo_size_end", mpp__init_read%t_proc(:)%i_lej )
-            CALL mpp_add_att(mpp__init_read, tl_att)
+            tl_att=att_init( "DOMAIN_number_total", mpp__init_file%i_nproc )
+            CALL mpp_add_att(mpp__init_file, tl_att)
+
+            tl_att=att_init( "DOMAIN_I_position_first", mpp__init_file%t_proc(:)%i_impp )
+            CALL mpp_add_att(mpp__init_file, tl_att)
+
+            tl_att=att_init( "DOMAIN_J_position_first", mpp__init_file%t_proc(:)%i_jmpp )
+            CALL mpp_add_att(mpp__init_file, tl_att)
+
+            tl_att=att_init( "DOMAIN_I_position_last", mpp__init_file%t_proc(:)%i_lci )
+            CALL mpp_add_att(mpp__init_file, tl_att)
+
+            tl_att=att_init( "DOMAIN_J_position_last", mpp__init_file%t_proc(:)%i_lcj )
+            CALL mpp_add_att(mpp__init_file, tl_att)
+
+            tl_att=att_init( "DOMAIN_I_halo_size_start", mpp__init_file%t_proc(:)%i_ldi )
+            CALL mpp_add_att(mpp__init_file, tl_att)
+
+            tl_att=att_init( "DOMAIN_J_halo_size_start", mpp__init_file%t_proc(:)%i_ldj )
+            CALL mpp_add_att(mpp__init_file, tl_att)
+
+            tl_att=att_init( "DOMAIN_I_halo_size_end", mpp__init_file%t_proc(:)%i_lei )
+            CALL mpp_add_att(mpp__init_file, tl_att)
+
+            tl_att=att_init( "DOMAIN_J_halo_size_end", mpp__init_file%t_proc(:)%i_lej )
+            CALL mpp_add_att(mpp__init_file, tl_att)
             
+            ! clean
+            CALL mpp_clean(tl_mpp)
+            CALL att_clean(tl_att)
 
          CASE('dimg')
             ! domain decomposition could be read in one file
 
-            tl_file=td_file
+            tl_file=file_copy(td_file)
             ! open file
+            CALL logger_debug("MPP INIT READ: open file "//TRIM(tl_file%c_name))
             CALL iom_open(tl_file)
 
+            CALL logger_debug("MPP INIT READ: read mpp structure ")
             ! read mpp structure
-            mpp__init_read=mpp__init_read_rstdimg(tl_file)
+            mpp__init_file=mpp__init_file_rstdimg(tl_file)
 
             ! mpp type
-            mpp__init_read%c_type=TRIM(td_file%c_type)
+            mpp__init_file%c_type=TRIM(td_file%c_type)
 
             ! mpp domain type
-            CALL mpp_get_dom(mpp__init_read)
+            CALL logger_debug("MPP INIT READ: mpp_get_dom ")
+            CALL mpp_get_dom(mpp__init_file)
 
             ! get processor size
-            DO ji=1,mpp__init_read%i_nproc
-
-               il_shape(:)=mpp_get_proc_size( mpp__init_read, ji )
+            CALL logger_debug("MPP INIT READ: get processor size ")
+            DO ji=1,mpp__init_file%i_nproc
+
+               il_shape(:)=mpp_get_proc_size( mpp__init_file, ji )
 
                tl_dim=dim_init('X',il_shape(1))
-               CALL file_add_dim(mpp__init_read%t_proc(ji), tl_dim)
+               CALL file_add_dim(mpp__init_file%t_proc(ji), tl_dim)
 
                tl_dim=dim_init('Y',il_shape(2))
-               CALL file_add_dim(mpp__init_read%t_proc(ji), tl_dim)            
+               CALL file_add_dim(mpp__init_file%t_proc(ji), tl_dim)            
+
+               ! clean
+               CALL dim_clean(tl_dim)
 
             ENDDO
@@ -879,10 +1098,30 @@
 
          CASE DEFAULT
-            CALL logger_error("INIT READ: invalid type for file "//&
+            CALL logger_error("MPP INIT READ: invalid type for file "//&
             &              TRIM(tl_file%c_name))
       END SELECT
 
-   END FUNCTION mpp__init_read
-   ! @endcode
+      ! east west overlap
+      IF( PRESENT(id_ew) ) mpp__init_file%i_ew=id_ew
+      ! NEMO periodicity
+      IF( PRESENT(id_perio) )THEN
+         mpp__init_file%i_perio= id_perio
+         SELECT CASE(id_perio)
+         CASE(3,4)
+            mpp__init_file%i_pivot=1
+         CASE(5,6)
+            mpp__init_file%i_pivot=0
+         CASE DEFAULT
+            mpp__init_file%i_pivot=1
+         END SELECT
+      ENDIF
+
+      IF( PRESENT(id_pivot) ) mpp__init_file%i_pivot= id_pivot
+
+      ! clean 
+      CALL file_clean(tl_file)
+
+      CALL logger_debug("MPP INIT READ: fin init_read ")
+   END FUNCTION mpp__init_file
    !-------------------------------------------------------------------
    !> @brief This function initalise a mpp structure, 
@@ -892,11 +1131,10 @@
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_file : file strcuture
+   !> - November, 2013- Initial Version
+   !>
+   !> @param[in] td_file   file strcuture
    !> @return mpp structure
    !-------------------------------------------------------------------
-   ! @code
-   TYPE(TMPP) FUNCTION mpp__init_read_cdf( td_file )
+   TYPE(TMPP) FUNCTION mpp__init_file_cdf( td_file )
       IMPLICIT NONE
 
@@ -906,12 +1144,16 @@
       ! local variable
       INTEGER(i4) :: il_attid  ! attribute id
+      
       LOGICAL     :: ll_exist
       LOGICAL     :: ll_open
 
       TYPE(TATT)  :: tl_att
+
+      TYPE(TDIM)  :: tl_dim
+      
       TYPE(TFILE) :: tl_proc
       !----------------------------------------------------------------
 
-      CALL logger_trace(" INIT READ: netcdf file "//TRIM(td_file%c_name))
+      CALL logger_trace("MPP INIT READ: netcdf file "//TRIM(td_file%c_name))
 
       INQUIRE( FILE=TRIM(td_file%c_name), EXIST=ll_exist, OPENED=ll_open )
@@ -921,13 +1163,13 @@
          IF( td_file%i_id == 0 )THEN
             CALL logger_info(" id "//TRIM(fct_str(td_file%i_id))) 
-            CALL logger_error("INIT READ: netcdf file "//TRIM(td_file%c_name)//&
+            CALL logger_error("MPP INIT READ: netcdf file "//TRIM(td_file%c_name)//&
             &  " not opened")
          ELSE
 
             ! get mpp name
-            mpp__init_read_cdf%c_name=TRIM( file_rename(td_file%c_name) )
+            mpp__init_file_cdf%c_name=TRIM( file_rename(td_file%c_name) )
 
             ! add type
-            mpp__init_read_cdf%c_type="cdf"
+            mpp__init_file_cdf%c_type="cdf"
 
             ! global domain size
@@ -937,22 +1179,24 @@
             ENDIF
             IF( il_attid /= 0 )THEN
-               mpp__init_read_cdf%t_dim(1)= &
-               &  dim_init('X',INT(td_file%t_att(il_attid)%d_value(1)))
-               mpp__init_read_cdf%t_dim(2)= &
-               &  dim_init('Y',INT(td_file%t_att(il_attid)%d_value(2)))
-            ELSE
-               mpp__init_read_cdf%t_dim(1)= &
-               &  dim_init( td_file%t_dim(1)%c_name, td_file%t_dim(1)%i_len)
-               mpp__init_read_cdf%t_dim(2)= &
-               &  dim_init( td_file%t_dim(2)%c_name, td_file%t_dim(2)%i_len)
-
-            ENDIF
-            mpp__init_read_cdf%t_dim(3)= &
-            &  dim_init( td_file%t_dim(3)%c_name, td_file%t_dim(1)%i_len)
-            mpp__init_read_cdf%t_dim(4)= &
-            &  dim_init( td_file%t_dim(4)%c_name, td_file%t_dim(2)%i_len)
+               tl_dim=dim_init('X',INT(td_file%t_att(il_attid)%d_value(1)))
+               CALL mpp_add_dim(mpp__init_file_cdf,tl_dim)
+
+               tl_dim=dim_init('Y',INT(td_file%t_att(il_attid)%d_value(2)))
+               CALL mpp_add_dim(mpp__init_file_cdf,tl_dim)
+            ELSE ! assume only one file (not mpp)
+               tl_dim=dim_init( td_file%t_dim(1)%c_name, td_file%t_dim(1)%i_len)
+               CALL mpp_add_dim(mpp__init_file_cdf,tl_dim)
+
+               tl_dim=dim_init( td_file%t_dim(2)%c_name, td_file%t_dim(2)%i_len)
+               CALL mpp_add_dim(mpp__init_file_cdf,tl_dim)
+            ENDIF
+            tl_dim=dim_init( td_file%t_dim(3)%c_name, td_file%t_dim(3)%i_len)
+            CALL mpp_add_dim(mpp__init_file_cdf,tl_dim)
+
+            tl_dim=dim_init( td_file%t_dim(4)%c_name, td_file%t_dim(4)%i_len)
+            CALL mpp_add_dim(mpp__init_file_cdf,tl_dim)
 
             ! initialise file/processor
-            tl_proc=td_file
+            tl_proc=file_copy(td_file)
 
             ! processor id
@@ -968,5 +1212,5 @@
 
             ! processor dimension
-            tl_proc%t_dim(:)=td_file%t_dim(:)
+            tl_proc%t_dim(:)=dim_copy(td_file%t_dim(:))
 
             ! DOMAIN_position_first
@@ -992,6 +1236,6 @@
                tl_proc%i_lcj = INT(td_file%t_att(il_attid)%d_value(2)) + tl_proc%i_jmpp
             ELSE
-               tl_proc%i_lci = mpp__init_read_cdf%t_dim(1)%i_len
-               tl_proc%i_lcj = mpp__init_read_cdf%t_dim(2)%i_len
+               tl_proc%i_lci = mpp__init_file_cdf%t_dim(1)%i_len
+               tl_proc%i_lcj = mpp__init_file_cdf%t_dim(2)%i_len
             ENDIF
 
@@ -1018,11 +1262,11 @@
                tl_proc%i_lej = INT(td_file%t_att(il_attid)%d_value(2))
             ELSE
-               tl_proc%i_lei = mpp__init_read_cdf%t_dim(1)%i_len
-               tl_proc%i_lej = mpp__init_read_cdf%t_dim(2)%i_len
+               tl_proc%i_lei = mpp__init_file_cdf%t_dim(1)%i_len
+               tl_proc%i_lej = mpp__init_file_cdf%t_dim(2)%i_len
             ENDIF
 
             ! add attributes
             tl_att=att_init( "DOMAIN_size_global", &
-            &                mpp__init_read_cdf%t_dim(:)%i_len)
+            &                mpp__init_file_cdf%t_dim(:)%i_len)
             CALL file_move_att(tl_proc, tl_att)
 
@@ -1047,16 +1291,18 @@
 
             ! add processor to mpp structure
-            CALL mpp__add_proc(mpp__init_read_cdf, tl_proc)
-
+            CALL mpp__add_proc(mpp__init_file_cdf, tl_proc)
+
+            ! clean 
+            CALL file_clean(tl_proc)
+            CALL att_clean(tl_att)
          ENDIF
 
       ELSE
 
-         CALL logger_error("INIT READ: netcdf file "//TRIM(td_file%c_name)//&
+         CALL logger_error("MPP INIT READ: netcdf file "//TRIM(td_file%c_name)//&
          &  " do not exist")
 
       ENDIF      
-   END FUNCTION mpp__init_read_cdf
-   ! @endcode
+   END FUNCTION mpp__init_file_cdf
    !-------------------------------------------------------------------
    !> @brief This function initalise a mpp structure, 
@@ -1066,11 +1312,10 @@
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_file : file strcuture
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] td_file   file strcuture
    !> @return mpp structure
    !-------------------------------------------------------------------
-   ! @code
-   TYPE(TMPP) FUNCTION mpp__init_read_rstdimg( td_file )
+   TYPE(TMPP) FUNCTION mpp__init_file_rstdimg( td_file )
       IMPLICIT NONE
 
@@ -1079,20 +1324,21 @@
 
       ! local variable
-      INTEGER(i4) :: il_status
-      INTEGER(i4) :: il_recl                          ! record length 
-      INTEGER(i4) :: il_nx, il_ny, il_nz              ! x,y,z dimension 
-      INTEGER(i4) :: il_n0d, il_n1d, il_n2d, il_n3d   ! number of 0/1/2/3D variables 
-      INTEGER(i4) :: il_iglo, il_jglo                 ! domain global size
-      INTEGER(i4) :: il_rhd                           ! record of the header infos
-      INTEGER(i4) :: il_pni, il_pnj, il_pnij          ! domain decomposition
-      INTEGER(i4) :: il_area                          ! domain index
-
-      LOGICAL     ::  ll_exist
-      LOGICAL     ::  ll_open
+      INTEGER(i4)       :: il_status
+      INTEGER(i4)       :: il_recl                          ! record length 
+      INTEGER(i4)       :: il_nx, il_ny, il_nz              ! x,y,z dimension 
+      INTEGER(i4)       :: il_n0d, il_n1d, il_n2d, il_n3d   ! number of 0/1/2/3D variables 
+      INTEGER(i4)       :: il_iglo, il_jglo                 ! domain global size
+      INTEGER(i4)       :: il_rhd                           ! record of the header infos
+      INTEGER(i4)       :: il_pni, il_pnj, il_pnij          ! domain decomposition
+      INTEGER(i4)       :: il_area                          ! domain index
+
+      LOGICAL           ::  ll_exist
+      LOGICAL           ::  ll_open
 
       CHARACTER(LEN=lc) :: cl_file
 
-      TYPE(TDIM)  :: tl_dim ! dimension structure
-      TYPE(TATT)  :: tl_att
+      TYPE(TDIM)        :: tl_dim ! dimension structure
+      TYPE(TATT)        :: tl_att
+      TYPE(TFILE)       :: tl_proc
 
       ! loop indices
@@ -1104,5 +1350,5 @@
 
          IF( .NOT. ll_open )THEN
-            CALL logger_error("INIT READ: dimg file "//TRIM(td_file%c_name)//&
+            CALL logger_error("MPP INIT READ: dimg file "//TRIM(td_file%c_name)//&
             &  " not opened")
          ELSE
@@ -1118,22 +1364,35 @@
             CALL fct_err(il_status)
             IF( il_status /= 0 )THEN
-               CALL logger_error("INIT READ: read first line header of "//&
+               CALL logger_error("MPP INIT READ: read first line header of "//&
                &              TRIM(td_file%c_name))
             ENDIF
 
             ! get mpp name
-            mpp__init_read_rstdimg%c_name=TRIM( file_rename(td_file%c_name) )
+            mpp__init_file_rstdimg%c_name=TRIM( file_rename(td_file%c_name) )
+
+            ! add type
+            mpp__init_file_rstdimg%c_type="dimg"
 
             ! number of processors to be read
-            mpp__init_read_rstdimg%i_nproc  = il_pnij
-            mpp__init_read_rstdimg%i_niproc = il_pni
-            mpp__init_read_rstdimg%i_njproc = il_pnj
-
-            IF( ASSOCIATED(mpp__init_read_rstdimg%t_proc) )THEN
-               DEALLOCATE(mpp__init_read_rstdimg%t_proc)
-            ENDIF
-            ALLOCATE( mpp__init_read_rstdimg%t_proc(il_pnij) , stat=il_status )
+            mpp__init_file_rstdimg%i_nproc  = il_pnij
+            mpp__init_file_rstdimg%i_niproc = il_pni
+            mpp__init_file_rstdimg%i_njproc = il_pnj
+
+            IF( ASSOCIATED(mpp__init_file_rstdimg%t_proc) )THEN
+               CALL file_clean(mpp__init_file_rstdimg%t_proc(:))
+               DEALLOCATE(mpp__init_file_rstdimg%t_proc)
+            ENDIF
+            ALLOCATE( mpp__init_file_rstdimg%t_proc(il_pnij) , stat=il_status )
+
+            tl_proc=file_copy(td_file)
+            ! remove dimension from file
+            CALL dim_clean(tl_proc%t_dim(:))
+            ! initialise file/processors
+            DO ji=1,mpp__init_file_rstdimg%i_nproc
+               mpp__init_file_rstdimg%t_proc(ji)=file_copy(tl_proc)
+            ENDDO
+
             IF( il_status /= 0 )THEN
-               CALL logger_error("INIT READ: not enough space to read domain &
+               CALL logger_error("MPP INIT READ: not enough space to read domain &
                &              decomposition in file "//TRIM(td_file%c_name))
             ENDIF
